﻿' -----------------------------------------------------------------------------------------
'
' DrehMain.vb                                                       Ulrich Müller  14.07.07
'                                                                   PCS1700 VB 2005 Express
' Drehzahlmessung eines fischertechnik Motors
' Motor an M2, Lichtschranke an M1 / I1
'          Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class DrehMain
  Const WalzenradDurchm As Integer = 52
  Const SchneckeZahn As Integer = 20
  Const ImpulseUmdrehung As Integer = 12
  Const Lampe As Out = Out.M1
  Const Photo As Inp = Inp.I1
  Const Motor As Out = Out.M2

  Dim ft As New FishFace()
  Dim MotorradDurchm As Integer
  Dim MessDauer As Integer
  Dim Zeit As Integer

  Private Sub Action()
    ft.SetMotor(Lampe, Dir.On)
    ft.SetMotor(Motor, Dir.Left)
    ft.Pause(1234)
    ft.ClearCounter(Photo)
    Zeit = 0
    MotorradDurchm = numMotorrolle.Value
    MessDauer = numMessdauer.Value
    prgMessung.Maximum = MessDauer
    prgMessung.Value = 0
    prgMessung.Visible = True
    tmrAction.Enabled = True

    ft.Pause(MessDauer * 1000)

    ft.SetMotor(Lampe, Dir.Off)
    ft.SetMotor(Motor, Dir.Off)
    tmrAction.Enabled = False
    prgMessung.Visible = False

    lblErgebnis.Text = DrehzahlMotor(MessDauer, _
      ft.GetCounter(Photo)).ToString("Drehzahl : 0  1/min")
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub

  Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region

  Private Sub tmrAction_Tick(ByVal sender As System.Object, _
                             ByVal e As System.EventArgs) Handles tmrAction.Tick
    Zeit += 1
    prgMessung.Value = Zeit
  End Sub

  Private Function DrehzahlMotor(ByVal Dauer As Integer, _
                                   ByVal Impulse As Integer) As Integer
    Dim DrehzahlRolle As Double = Impulse / ImpulseUmdrehung * (60 / Dauer)
    Dim Uebersetzung As Double = WalzenradDurchm * SchneckeZahn / MotorradDurchm
    Return DrehzahlRolle * Uebersetzung
  End Function
End Class
