﻿' -----------------------------------------------------------------------------------------
'
' RCcarRollen.vb                                                    Ulrich Müller  09.07.07
'                                                                   PCS1700 VB 2005 Express
' RC CAr : Rollenprüfstand, Messen der Fahrgeschwindigkeit
'          Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class RCcarRollen
  Const AutoradDurchm As Integer = 31
  Const RollenradDurchm As Integer = 52
  Const SchneckeZahn As Integer = 20
  Const ImpulseUmdrehung As Integer = 12
  Const MessDauer As Integer = 15
  Const Lampe As Out = Out.M1
  Const Photo As Inp = Inp.I1

  Dim ft As New FishFace()
  Dim Zeit As Integer

  Private Sub Action()
    ft.SetMotor(Lampe, Dir.On)
    ft.Pause(1234)
    ft.ClearCounter(Photo)
    Zeit = 0
    prgMessung.Maximum = MessDauer
    prgMessung.Value = 0
    prgMessung.Visible = True
    tmrAction.Enabled = True
    ft.Pause(MessDauer * 1000)

    ft.SetMotor(Lampe, Dir.Off)
    tmrAction.Enabled = False
    prgMessung.Visible = False
    lblErgebnis.Text = Geschwindigkeit(MessDauer, _
      ft.GetCounter(Photo)).ToString("Geschwindigkeit : 0.00 km/h")
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub

  Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region

  Private Sub tmrAction_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrAction.Tick
    Zeit += 1
    prgMessung.Value = Zeit
    prgGeschwindigkeit.Value = Geschwindigkeit(Zeit, ft.GetCounter(Photo))
  End Sub

  Private Function Geschwindigkeit(ByVal Dauer As Integer, ByVal Impulse As Integer) As Double
    Dim DrehzahlRolle As Double = Impulse / ImpulseUmdrehung * (60 / Dauer)
    Dim Uebersetzung As Double = RollenradDurchm * SchneckeZahn / AutoradDurchm
    Dim DrehzahlAuto As Double = DrehzahlRolle * Uebersetzung
    Dim WegAutoMM As Double = DrehzahlAuto * AutoradDurchm * Math.PI
    Dim GeschwAutoMS As Double = WegAutoMM / 60000
    Return GeschwAutoMS * 3.6
  End Function
End Class
